/*
  Top10, a racing simulator
  Copyright (C) 2000-2005  Johann Deneux
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  
  Authors can be contacted at following electronic addresses:
  Johann Deneux: johann.deneux@it.uu.se
*/

#ifndef TOP10_GRAPHX_TEXTURENODE_HH
#define TOP10_GRAPHX_TEXTURENODE_HH

#include "GroupNode.hh"
#include "RenderState.hh"

namespace top10 {
  namespace graphX {

    //! Texture to use for texture mapping.
    /*! Applies to all children */
    class TextureNode: public GroupNode {
    public:      
      TextureNode(): texture_id(0), filtering(RenderState::Linear) {}

    protected:
      inline void modifyRenderState(RenderState& s) const {
        s.setTextureId(texture_id);
        s.setFiltering(filtering);
      }

    public:
      unsigned int texture_id;
      RenderState::Filtering filtering;
    };

  };
};

#endif
